/*
 * aufgabe1.c
 *
 *  Created on: 14.01.2013
 *      Author: johann
 */



#include<stdio.h>
#include<stdlib.h>
#include<math.h>


//    Funktionsdeklaration


void erzeugeDaten(double a, double b, int N, double *x, double *y);
void schreibeDaten(FILE * out, int N, double *x, double *y);

//    Hauptprogramm


int main()
{
  FILE *out;
  double ob_gr = 20.0, unt_gr = -20.0;	/*Intervallgrenzen */
  int N = 41;		/* Anzahl der Stuetzstellen */
  double *x, *y;


  /* Felder erzeugen */
  x= (double*) calloc(N, sizeof(double));
  y= (double*) calloc(N, sizeof(double));

  if (NULL==x || NULL == y)
  {
	  printf("Zu wenig freier Speicher!\n");
	  free(x);free(y);
	  return 1;
  }



  /* Speicherplatz reservieren */
  erzeugeDaten(unt_gr, ob_gr, N, x, y);

  /* Datei oeffnen */
  out = fopen("square.dat", "w");

  /* auf Fehler testen */
  if (!out)
  {
    fprintf(stderr, "Fehler beim Oeffnen der Datei");
    return 1;
  }

  /* Daten in der Datei abspeichern */
  schreibeDaten(out, N, x, y);

  /* Datei schliessen */
  fclose(out);

  return 0;
}


//    Funktionsdefinition


void erzeugeDaten(double a, double b, int N, double *x, double *y)
{
  int i;
  double h = (b - a) / (N - 1.0);	/* Schrittweite h */

  for (i = 0; i < N; i++)
  {
    x[i] = a + i * h;
    y[i] = x[i] * x[i];
  }
}

void schreibeDaten(FILE * out, int N, double *x, double *y)
{
  int i;
  for (i = 0; i < N; ++i)
  {
    fprintf(out, "%6.2lf %6.2lf\n", x[i], y[i]);
  }
}
