/*
 * aufgabe2.c
 *
 *  Created on: 14.01.2013
 *      Author: johann
 */


#include<stdio.h>
#include<stdlib.h>
#include<math.h>

/*****************************/
/*    Funktionsdeklaration   */
/*****************************/

double **neueMatrix(int anz_zl, int anz_sp);
double **liesDaten(FILE *in, int anz_z, int anz_sp);
void schreibeDaten(FILE *out, int N, double *x, double *y);
void zeigeMatrix(double **mat, int anz_zl, int anz_sp);

/***********************/
/*    Hauptprogramm    */
/***********************/

int main(void)
{
  //anz_st = Anzahl der Stuetzstellen, an denen die Geradengleichung ausgewertet
  //         werden soll.
  //anz_z = Anzahl der Patienten bzw. Zeilen
  //anz_sp = Anzahl der Spalten

  int i, anz_st = 200, anz_z = 50, anz_sp = 2;
  double a = 0.0, b = 0.0, y_quer = 0.0, t_quer = 0.0, zaehler = 0.0, 
    nenner = 0.0;
  double t[anz_st], y[anz_st], err[anz_z];
  double **A;
  FILE *in, *out;

  // Test, ob Datei lesbar
  if (NULL == (in = fopen("leastsquare.dat", "r")))
  {
    printf("\n\nDatei kann nicht geoeffnet werden!!\n\n");
    return 1;
  }

  // Daten einlesen
  A = liesDaten(in, anz_z, anz_sp);

  if (NULL == A)
  {
    printf("\n\nA kann nicht generiert werden! Abbruch!\n\n");
    fclose(in);
    return 1;
  }
  printf("\nDie Datei least_square.dat:\n");
  printf("\n1. Spalte: Koerpergroesse, 2. Spalte: Puls\n");
  zeigeMatrix(A, anz_z, anz_sp);

  // Methode der kleinsten Fehlerquadrate
  // 1.Spalte von A: Koerpergroesse, 2.Spalte: Puls

  // Berechnung der Mittelwerte y_quer, t_quer
  for (i = 0; i < anz_z; i++)
  {
    t_quer += A[i][0];
    y_quer += A[i][1];
  }

  t_quer = t_quer / anz_z;
  y_quer = y_quer / anz_z;

  printf("\nt_quer = %lf, y_quer = %lf\n", t_quer, y_quer);

  // Berechnung der Steigung a
  for (i = 0; i < anz_z; i++)
  {
    zaehler += (A[i][0] - t_quer) * (A[i][1] - y_quer);
    nenner  += (A[i][0] - t_quer) * (A[i][0] - t_quer);
  }

  a = zaehler / nenner;

  // Berechnung des y-Achsenabschnittes b
  b = y_quer - a * t_quer;


  // Berechnung der Geradenpunkte
  for(i=0;i<anz_st;i++)
  {
    y[i]= a*i+b;
    t[i]=i;
  }
  
  // Berechnung des Fehlers
  for (i = 0; i < anz_z; i++)
    err[i] = fabs(a * A[i][0] + b - A[i][1]);
  

  printf("\nDie Geradengleichung lautet: y = %lft%+lf.\n\n", a, b);
  printf("\nDer Fehler lautet:\n");
  for(i = 0; i < anz_z; i++)
    printf("err[%2d] = %5.2lf\n",i, err[i]);
  

  // Datei oeffnen
  out = fopen("gerade.dat", "w");

  // auf Fehler testen
  if (NULL == out)
  {
    fprintf(stderr, "\nFehler beim Oeffnen der Datei\n");
    return 1;
  }

  // Abspeichern der Wertetabelle in Datei
  schreibeDaten(out, anz_st, t, y);

  // Datei schliessen 
  fclose(out);

  return 0;
}

/*****************************/
/*    Funktionsdefinition   */
/*****************************/

// neue Matrix
double **neueMatrix(int anz_zl, int anz_sp)
{
  int i, j;
  double **dpt;

  dpt = (double **) malloc(anz_zl * sizeof(double *));
  if (NULL == dpt)
    return NULL;

  for (i = 0; i < anz_zl; i++)
  {
    dpt[i] = malloc(anz_sp * sizeof(double));
    if (NULL == dpt[i])
    {
      for (j = 0; j < i; j++)
	free(dpt[j]);
      free(dpt);
      return NULL;
    }
  }
  return dpt;
}

// Daten einlesen 
double **liesDaten(FILE *in, int anz_z, int anz_sp)
{
  int i, j;
  double **A;

  A = neueMatrix(anz_z, anz_sp);

  if (NULL == A)
  {
    printf("\n\nSpeicherplatzreservierung fuer A gescheitert!\n\n");
    return NULL;
  }

  for (i = 0; i < anz_z; i++)
  {
    for (j = 0; j < anz_sp; j++)
    {
      if (0 == fscanf(in, "%lf", *(A + i) + j))
      {
	printf("\n\nBeim Einlesen der Matrix gescheitert!\n\n");
	return NULL;
      }
    }
  }
  return A;
}

// Wertetabelle in Datei schreiben
void schreibeDaten(FILE *out, int N, double *x, double *y)
{
  int i;
  for (i = 0; i < N; ++i)
  {
    fprintf(out, "%f %f\n", x[i], y[i]);
  }
}

// zeige Matrix
void zeigeMatrix(double **mat, int anz_zl, int anz_sp)
{
  int i, j;
  printf("\n\n");
  for (i = 0; i < anz_zl; i++)
  {
    for (j = 0; j < anz_sp; j++)
      printf("% 7.2lf ", mat[i][j]);
    printf("\n");
  }
}
